


#include "Affichages.h"
#include "SPI.h"
#include "MAX7219.h"
#include "Font5x7.h"
#include "Utilitaires.h"



extern unsigned char g_Affichages[NOMBRE_COLONNES];



extern unsigned char g_Mot[8];



void Scrutation(int Maintient)
{
	unsigned char Colonne;	/* Variable qui indique  quelle colonne les donnes sont envoyes. */
	unsigned char k = 0;
	
	for(Colonne = MAX7219_DIGIT_0; Colonne <= NOMBRE_COLONNES; Colonne++)
	{
		EcrireRegistreMAX7219(Colonne, g_Affichages[k]);		 
		k++;
	}
	Delai(Maintient);
}



void ActiverEnsemble(unsigned char Direction, unsigned char Numero, unsigned char Contenu)
{
	unsigned char k;

	switch(Direction)
	{
		case 'X' :
		{
			g_Affichages[Numero] = Retourner(Contenu);
			break;
		}
		case 'Y' :
		{
			Contenu = Retourner(Contenu);
			for(k = 0; k < NOMBRE_COLONNES; k++)
			{
				if(TesterPositionPariculiere(Contenu, k) == 1)
				{
					g_Affichages[7 - k] |= (1 << (7 - Numero));
				}
			}
			break;
		}
		default :
		{
			break;
		}
	}

}



void ActiverEnsemble0(unsigned char Numero, unsigned char Contenu)
{
	unsigned char k;
	unsigned char l;

	unsigned char Tampon;

	for(k = 0; k < NOMBRE_COLONNES; k++)
	{
		if(k == Numero)
		{
			Tampon = Contenu;
		}
		else
		{
			Tampon = 0x00;
		}

		for(l = 0; l < NOMBRE_COLONNES; l++)
		{
			g_Affichages[k] = Tampon;
		}
	}
}



void ActiverEnsemble1(unsigned char Numero, unsigned char Contenu)
{
	unsigned char k;

	unsigned char Tampon;

	for(k = 0; k < NOMBRE_COLONNES; k++)
	{
		if(k == Numero)
		{
			Tampon = Contenu;
		}
		else
		{
			Tampon = 0x00;
		}

		g_Affichages[k] = Tampon;
	}
}



void ActiverDiagonale(unsigned char Orientation, unsigned char Contenu)
{
	unsigned char k;
	unsigned char l;



	switch(Orientation)
	{
		case 1 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					if(TesterPositionPariculiere(Contenu, k))
					{
						g_Affichages[k] |= (1 << k);	/*  |= (1 << k); */
						/* Tampon = TamponCaractere[l];
						g_Affichages[Z + l][7 - X] |= (Tampon << Y); */
					}
				}
			}
			break;
		}
		case 2 :
		{
			for(k = 0; k < 8; k++)
			{
				for(l = 0; l < NOMBRE_COLONNES; l++)
				{
					if(TesterPositionPariculiere(Contenu, k))
					{
						g_Affichages[k] |= (1 << (7 - k));	/*  |= (1 << k); */
						/* Tampon = TamponCaractere[l];
						g_Affichages[Z + l][7 - X] |= (Tampon << Y); */
					}
				}
			}
			break;
		}
		default :
		{
			break;
		}
	}
}



void AfficherCaractere0(unsigned char Numero, unsigned char Remanence, unsigned char Caractere)
{
	unsigned char k;

	unsigned char Tampon;

	int Endroit;

	Endroit = (5 * (((int)Caractere) - 0x20));


	for(k = 0; k < NOMBRE_COLONNES; k++)
	{
		if(k == Numero)
		{
			Tampon = Font5x7[Endroit + k];
			g_Affichages[k] = Tampon;
		}
		else
		{
			if(Remanence == 0)
			{
				g_Affichages[k] = 0x00;
			}
		}
	}
}



void AfficherCaractere1(unsigned char Numero, unsigned char Remanence, unsigned char Caractere)
{
	unsigned char k;

	unsigned char Tampon;

	int Endroit;

	Endroit = (5 * (((int)Caractere) - 0x20));


	for(k = 0; k < NOMBRE_COLONNES; k++)
	{
		if(k < 5)
		{
			Tampon = Font5x7[Endroit + k];
			g_Affichages[k]= Tampon;
		}
		else
		{
			if(Remanence == 0)
			{
				g_Affichages[k] = 0x00;
			}
		}
	}
}



void AllumerMatrice(void)
{			   
	unsigned char k;

	for(k = 0; k < NOMBRE_COLONNES; k++)
	{
		g_Affichages[k] = 0xFF;
	}
}



void EteindreMatrice(void)
{
	unsigned char k;

	for(k = 0; k < NOMBRE_COLONNES; k++)
	{
		g_Affichages[k] = 0x00;
	}
}



void AfficherPoint(unsigned char X, unsigned char Y)
{
	if(X > 7)
	{
		X = 1;
	}
	if(Y > 7)
	{
		Y = 1;
	}
	g_Affichages[7 - X] |= (1 << Y);
}



void EteindrePoint(unsigned char X, unsigned char Y)
{
	g_Affichages[7 - X] &= (~(1 << Y));
}



void AfficherLigne(unsigned char X, unsigned char Y, unsigned char Longueur, unsigned char Orientation)
{
	unsigned char k;

	switch(Orientation)
	{
		case 'X' :
		{
			for(k = 0; k < Longueur; k++)
			{
				AfficherPoint((X + k), Y);
			}
			break;
		}
		case 'Y' :
		{
			for(k = 0; k < Longueur; k++)
			{
				AfficherPoint(X, (Y + k));
			}
			break;
		}
		default :
		{
			break;
		}
	}
}



void AfficherLigneOblique(unsigned char X, unsigned char Y, unsigned char Longueur, unsigned char Orientation)
{
	unsigned char k;

	switch(Orientation)
	{
		case 0 :
		{
			for(k = 0; k < Longueur; k++)
			{
				AfficherPoint((X + k), (Y - k));
			}
			break;
		}
		case 1 :
		{
			for(k = 0; k < Longueur; k++)
			{
				AfficherPoint((X + k), (Y + k));
			}
			break;
		}
		default :
		{
			break;
		}
	}

}



void AfficherAngle(unsigned char Longueur, unsigned char Orientation, unsigned char Volume)
{
	switch(Orientation)
	{
		case 1 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(0, 0, Longueur, 'Y');
				AfficherLigne(0, 0, Longueur, 'X');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique(0, (Longueur - 1), Longueur, 0);
			}

			break;
		}
		case 2 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(0, (8 - Longueur), Longueur, 'Y');
				AfficherLigne(0, 7, Longueur, 'X');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique(0, (8 - Longueur), Longueur, 1);
			}

			break;
		}
		case 3 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(7, (8 - Longueur), Longueur, 'Y');
				AfficherLigne((8 - Longueur), 7, Longueur, 'X');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique((8 - Longueur), 7, Longueur, 0);
			}

			break;
		}
		case 4 :
		{
			if((0x01 & Volume) == 0x01)
			{
				AfficherLigne(7, 0, Longueur, 'Y');
				AfficherLigne((8 - Longueur), 0, Longueur, 'X');
			}
		
			if((0x02 & Volume) == 0x02)
			{
				AfficherLigneOblique((8 - Longueur), 0, Longueur, 1);
			}

			break;
		}
		default:
		{
			break;
		}
	}
}



void AfficherFleches(unsigned char Direction, unsigned char Style, unsigned char Decalage)
{
	unsigned char k;

	const unsigned char Fleche[4] = {0x41, 0x22, 0x14, 0x08};

	if(Direction == 0)	/* Si l'on souhaite afficher des flches qui vont vers la gauche */
	{
		for(k = 0; k <= 7; k++)
		{
			g_Affichages[k] = Fleche[(7 + k - Decalage) % 4];
			if(Style == 0)	/* Si l'on souhaite avoir un affichage des flches qui vont vers la gauche en ngatif */
			{
				g_Affichages[k] = (0x7F & (~g_Affichages[k]));
			}
		}
	}
	if(Direction == 1)	/* Si l'on souhaite afficher des flches qui vont vers la droite */
	{
		for(k = 0; k <= 7; k++)
		{
			g_Affichages[7 - k] = Fleche[(7 + k - Decalage) % 4];
			if(Style == 0)	/* Si l'on souhaite avoir un affichage des flches qui vont vers la droite en ngatif */
			{
				g_Affichages[7 - k] = (0x7F & (~g_Affichages[7 - k]));
			}
		}
	}
}



void AfficherRectangle(unsigned char X, unsigned char Y, unsigned char A, unsigned char B)
{
	unsigned char k;

	if(X > 7)
	{
		X = 0;
	}

	if(Y > 7)
	{
		Y = 0;
	}

	if(A > 8)
	{
		A = 1;
	}

	if(B > 8)
	{
		B = 1;
	}

	for(k = 0; k < A; k++)
	{
		AfficherPoint((X + k), Y);
	}	

	for(k = 0; k < B; k++)
	{
		AfficherPoint(X, (Y + k));
	}

	for(k = 0; k < A; k++)
	{
		AfficherPoint((X + k), Y);
	}

	for(k = 0; k < A; k++)
	{
		AfficherPoint((X + k), (Y + B - 1));
	}

	for(k = 0; k < A; k++)
	{
		AfficherPoint((X + k), (Y + B - 1));
	}

	for(k = 0; k < B; k++)
	{
		AfficherPoint(X, (Y + k));
	}

	for(k = 0; k < B; k++)
	{
		AfficherPoint((X + A - 1), (Y + k));
	}

	for(k = 0; k < B; k++)
	{
		AfficherPoint((X + A - 1), (Y + k));
	}
}



void AfficherCaractere(short int X, short int Y, unsigned char Rotation, unsigned char Miroir, unsigned char Caractere)
{
	unsigned char k;



	unsigned char l;



	unsigned char Tampon;



	unsigned char TamponCaractere[8] = {0x00};



	int Endroit;



	Endroit = (8 * (((int)Caractere) - 0x20));



	switch(Rotation)
	{
		case 0 :
		{
			Rotation = 0;
			break;
		}
		case 1 :
		{
			Rotation = 3;
			break;
		}
		case 2 :
		{
			Rotation = 2;
			break;
		}
		case 3 :
		{
			Rotation = 1;
			break;
		}
		default :
		{
			break;
		}
	}



	for(k = 0; k < 8; k++)
	{
		switch(Rotation)
		{
			case 0 :
			{
				TamponCaractere[k] = Font5x7[Endroit + k];
				break;
			}
			case 1 :
			{
				for(l = 0; l < 8; l++)
				{
					TamponCaractere[7 - l] |= (TesterPositionPariculiere(Font5x7[Endroit + k], l) << k);
				}
				break;
			}
			case 2 :
			{
				TamponCaractere[7 - k] = Retourner(Font5x7[Endroit + k]);
				break;
			}
			case 3 :
			{
				for(l = 0; l < 8; l++)
				{
					TamponCaractere[l] |= (TesterPositionPariculiere(Font5x7[Endroit + (7 - k)], l) << k);
				}
				break;
			}
			default :
			{
	
				break;
			}
		}
	}



	if(Miroir == 0)
	{
		Tampon = TamponCaractere[7];
		TamponCaractere[7] = TamponCaractere[0];
		TamponCaractere[0] = Tampon;

		Tampon = TamponCaractere[6];
		TamponCaractere[6] = TamponCaractere[1];
		TamponCaractere[1] = Tampon;

		Tampon = TamponCaractere[5];
		TamponCaractere[5] = TamponCaractere[2];
		TamponCaractere[2] = Tampon;

		Tampon = TamponCaractere[4];
		TamponCaractere[4] = TamponCaractere[3];
		TamponCaractere[3] = Tampon;
	}

	for(k = 0; k < NOMBRE_COLONNES; k++)
	{
		Tampon = TamponCaractere[k];
		if(((X + k) >= 0) && ((X + k) <= (NOMBRE_COLONNES - 1)))
		{
			if(Y < 0)
			{
				g_Affichages[X + k] |= (Tampon >> (-Y));
			}
			else
			{
				g_Affichages[X + k] |= (Tampon << Y);
			}
		}
	}
		/* for(k = 0; k < 8; k++)
		{
			for(l = 0; l < NOMBRE_COLONNES; l++)
			{
				Tampon = TamponCaractere[k];
				g_Affichages[(7 - k) - X] |= (((Tampon & (1 << l)) >> l) << Y);
			}
		} */
}


