


#include <stm32f10x.h>

#include "SPI.h"
#include "MAX7219.h"
#include "Affichages.h"
#include "Effets.h"
#include "Utilitaires.h"



unsigned char g_Affichages[NOMBRE_COLONNES];



extern const unsigned char Tailles0[64];
extern const unsigned char Tailles1[64];
extern const unsigned char Tailles2[64];
extern const unsigned char Tailles3[64];



int main(void)
{
	unsigned char k;
	unsigned char r;

	short int p;

	int v;



	RCC->APB2ENR |= (1 << 2);	/* Activation de l'horloge du port A */
	

	
	InitSPI1();
	InitITSPI1();



	EcrireRegistreMAX7219(MAX7219_SHUTDOWN, 0x00);	/* Shutdown : placement en  Shutdown Mode  */

	EcrireRegistreMAX7219(MAX7219_DECODE_MODE, 0x00);	/* Aucun dcodage pour tous les afficheurs, les
		octets de donnes envoys dfinissent l'affichage */

	EcrireRegistreMAX7219(MAX7219_SCAN_LIMIT, (NOMBRE_COLONNES - 1));	/* Pilotage des 8 afficheurs */

	EcrireRegistreMAX7219(MAX7219_INTENSITY, 0x0F);	/* Intensit du courant dlivr dans les diodes maximale,
		utilisant un rapport cyclique de 31 / 32.
		0x00 : 1 / 32, minimum,
		0x0F : 31 / 32, maximum. */

	EcrireRegistreMAX7219(MAX7219_DISPLAY_TEST, 0x00);	/* Dispaly Test : placement en  Normal Operation  */



	EcrireRegistreMAX7219(MAX7219_SHUTDOWN, 0x01);	/* Shutdown : placement en  Normal Operation  */



	while(1)
	{
/* -------------------------------- Dbut de l'effet  Balayages  -------------------------------- */

		for(v = 'X'; v <= 'Y'; v++)
		{
			BalayerLignes(v, 2000);
			BalayerLignes(v, 3000);
			BalayerLignes(v, 6000);
			BalayerLignes(v, 3000);
			BalayerLignes(v, 2000);
		}

/* -------------------------------- Fin de l'effet  Balayages  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Remplissages  -------------------------------- */

		for(v = 'X'; v <= 'Y'; v++)
		{
			RemplirLignes(v, 2000);
			RemplirLignes(v, 3000);
			RemplirLignes(v, 6000);
			RemplirLignes(v, 3000);
			RemplirLignes(v, 2000);
		}

/* -------------------------------- Fin de l'effet  Remplissages  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Diagonales pleines  -------------------------------- */

		for(k = 0; k < 3; k++)
		{
			for(p = 1000; p < 10000; p = (p + 2000))
			{
				for(v = 1; v <= 2; v++)
				{
					EteindreMatrice();
					ActiverDiagonale(v, 0xFF);
					Scrutation(p);
				}
			}
		
			for(p = 10000; p >= 1000; p = (p - 2000))
			{
				for(v = 1; v <= 2; v++)
				{
					EteindreMatrice();
					ActiverDiagonale(v, 0xFF);
					Scrutation(p);
				}
			}
		}

/* -------------------------------- Fin de l'effet  Diagonales pleines  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Tourniquet  -------------------------------- */

		for(k = 0; k < 3; k++)
		{
			EteindreMatrice();
			ActiverEnsemble('Y', 3, 0xFF);
			ActiverEnsemble('Y', 4, 0xFF);
			Scrutation(10000);
	
			EteindreMatrice();
			ActiverDiagonale(2, 0xFF);
			Scrutation(10000);
	
			EteindreMatrice();
			ActiverEnsemble('X', 3, 0xFF);
			ActiverEnsemble('X', 4, 0xFF);
			Scrutation(10000);
	
			EteindreMatrice();
			ActiverDiagonale(1, 0xFF);
			Scrutation(10000);
		}



		EteindreMatrice();
		ActiverEnsemble('Y', 3, 0xFF);
		ActiverEnsemble('Y', 4, 0xFF);
		Scrutation(10000);

		EteindreMatrice();

/* -------------------------------- Fin de l'effet  Tourniquet   -------------------------------- */



/* -------------------------------- Dbut de l'effet  Segments croiss  -------------------------------- */

		CroiserLignes(10000);

/* -------------------------------- Fin de l'effet  Segments croiss  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Variations  -------------------------------- */

		AllumerMatrice();
		Scrutation(1000);

		for(k = 0; k < 3; k++)
		{
			for(p = 0x00; p < 0x0F; p++)
			{ 
				EcrireRegistreMAX7219(MAX7219_INTENSITY, p);	/* Intensit du courant dlivr dans les diodes
					qui augmente progressivement, de 0x00 : rapport cyclique de 1 / 32, minimal, jusqu' 0x0E : rapport cyclique de 29 / 32 */
				Delai(1000);
			}
			for(p = 0x0F; p >= 0x00; p--)
			{ 
				EcrireRegistreMAX7219(MAX7219_INTENSITY, p);	/* Intensit du courant dlivr dans les diodes
					qui diminue progressivement, de 0x0F : rapport cyclique de 31 / 32, maximal, jusqu' 0x00 : rapport cyclique de 1 / 32, minimal */
				Delai(1000);
			}
		}

		EteindreMatrice();
		EcrireRegistreMAX7219(MAX7219_INTENSITY, 0x0F);	/* Intensit du courant dlivr dans les diodes maximale,
			utilisant un rapport cyclique de 31 / 32.
			0x00 : 1 / 32, minimum,
			0x0F : 31 / 32, maximum. */

/* -------------------------------- Fin de l'effet  Variations  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Points alatoires  -------------------------------- */

		EffetPointsVariables(1, 100);
		EffetPointsVariables(7, 500);
		EffetPointsVariables(1, 100);

/* -------------------------------- Fin de l'effet  Points alatoires  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Lignes  -------------------------------- */

		for(v = 1000; v <= 7000; (v = v + 3000))
		{
			EffetLignes(v);	
		}

/* -------------------------------- Fin de l'effet  Lignes  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Formes  -------------------------------- */

		EffetFormes(5000);

/* -------------------------------- Fin de l'effet  Formes  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Serpent  -------------------------------- */

		EffetSerpent(1000);
		EffetSerpent(5000);
		EffetSerpent(1000);

/* -------------------------------- Fin de l'effet  Serpent  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Hlice simple  -------------------------------- */

		for(p = 10000; p > 2000; p = (p - 2000))
		{
			EffetGrosseHelice(p);
		}

		for(p = 2000; p < 10000; p = (p + 2000))
		{
			EffetGrosseHelice(p);
		}

/* -------------------------------- Fin de l'effet  Hlice simple  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Quatre hlices  -------------------------------- */

		for(p = 10000; p > 2000; p = (p - 2000))
		{
			EffetPetitesHelices(p);
		}

		for(p = 2000; p < 10000; p = (p + 2000))
		{
			EffetPetitesHelices(p);
		}

/* -------------------------------- Fin de l'effet  Quatre hlices  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Diagonales partielles  -------------------------------- */

 		for(k = 0; k < 5; k++)
		{
			for(v = 1; v <= 2; v++)
			{
				EteindreMatrice();
				ActiverDiagonale(v, 0x55);
				Scrutation(10000);
			}
		}

/* -------------------------------- Fin de l'effet  Diagonales partielles  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Flches  -------------------------------- */

		for(k = 0; k < 2; k++)
		{
			for(v = 0; v < 2; v++)
			{
				for(p = 0; p < 5; p++)
				{
					EffetFleches(v, k, 10000);
				}
			}
		}

/* -------------------------------- Fin de l'effet  Flches  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Angles  -------------------------------- */

		for(k = 1; k <= 3; k++)
		{
			for(r = 1; r <= 4; r++)
			{
				for(v = 1; v < 8; v++)
				{
					AfficherAngle(v, r, k);
				
					Scrutation(3000);
				
					EteindreMatrice();
				}
		
				for(v = 8; v > 0; v--)
				{
					AfficherAngle(v, r, k);
				
					Scrutation(3000);
				
					EteindreMatrice();
				}
			}
			for(v = 1; v < 4; v++)
			{
				EffetAngles(v, k, 10000);
			}
			for(v = 4; v >= 1; v--)
			{
				EffetAngles(v, k, 10000);
			}
		}

/* -------------------------------- Fin de l'effet  Angles  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Carr centr  -------------------------------- */

		for(v = 2; v <= 3; v++)
		{
			EffetAngles(v, 0x01, 10000);
		}



		EffetCarreCentre(0, 10000);



		for(v = 5000; v < 10000; (v = (v + 5000)))
		{
			EffetCarreCentre(1, v);
			EffetCarreCentre(0, v);
		}
		for(v = 15000; v > 0; (v = (v - 5000)))
		{
			EffetCarreCentre(1, v);
			EffetCarreCentre(0, v);
		}

		EteindreMatrice();

/* -------------------------------- Fin de l'effet  Carr centr  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Carr coins  -------------------------------- */

		AfficherRectangle(2, 2, 2, 2);
		Scrutation(3000);

		EteindreMatrice();
		AfficherRectangle(1, 1, 2, 2);
		Scrutation(3000);

		EteindreMatrice();
		AfficherRectangle(0, 0, 2, 2);
		Scrutation(3000);



		EffetCarreVariable(0, 5000);

		EteindreMatrice();

/* -------------------------------- Fin de l'effet  Carr coins  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Carr baladeur  -------------------------------- */

		AfficherRectangle(0, 0, 1, 1);
		Scrutation(3000);

		EteindreMatrice();
		AfficherRectangle(0, 0, 2, 2);
		Scrutation(3000);
		
		AfficherRectangle(0, 0, 3, 3);
		Scrutation(3000);
		
		AfficherRectangle(0, 0, 4, 4);
		Scrutation(3000);

		

		EffetCarreBaladeur(5, 10000);
		EffetCarreBaladeur(5, 9000);
		EffetCarreBaladeur(4, 8000);
		EffetCarreBaladeur(4, 7000);
		EffetCarreBaladeur(3, 6000);
		EffetCarreBaladeur(3, 5000);
		EffetCarreBaladeur(3, 4000);
		EffetCarreBaladeur(2, 3000);
		EffetCarreBaladeur(2, 2000);


/* -------------------------------- Fin de l'effet  Carr baladeur  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Rectangles alatoires  -------------------------------- */

		EffetRectanglesVariables(3000);

/* -------------------------------- Fin de l'effet  Rectangles alatoires  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Analyseur audio  -------------------------------- */

		EffetLignesVariables(5000);

/* -------------------------------- Fin de l'effet  Analyseur audio  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Cur qui bat  -------------------------------- */

		for(k = 0; k < 5; k++)
		{



			/* Dessin d'un petit cur */

			g_Affichages[7] = 0x00;
			g_Affichages[6] = 0x00;
			g_Affichages[5] = 0x00;
			g_Affichages[4] = 0x10;
			g_Affichages[3] = 0x20;
			g_Affichages[2] = 0x10;
			g_Affichages[1] = 0x00;
			g_Affichages[0] = 0x00;
		
			Scrutation(20000);
		
			Delai(20000);
		
			EteindreMatrice();



			/* Dessin d'un cur moyen */

			g_Affichages[7] = 0x00;
			g_Affichages[6] = 0x00;
			g_Affichages[5] = 0x18;
			g_Affichages[4] = 0x24;
			g_Affichages[3] = 0x48;
			g_Affichages[2] = 0x24;
			g_Affichages[1] = 0x18;
			g_Affichages[0] = 0x00;
		
			Scrutation(5000);
		
			Delai(5000);
		
			EteindreMatrice();



			/* Dessin d'un gros cur */

			g_Affichages[7] = 0x00;
			g_Affichages[6] = 0x1C;
			g_Affichages[5] = 0x22;
			g_Affichages[4] = 0x42;
			g_Affichages[3] = 0x84;
			g_Affichages[2] = 0x42;
			g_Affichages[1] = 0x22;
			g_Affichages[0] = 0x1C;
		
			Scrutation(10000);
		
			Delai(10000);
		
			EteindreMatrice();



			/* Dessin d'un cur moyen */

			g_Affichages[7] = 0x00;
			g_Affichages[6] = 0x00;
			g_Affichages[5] = 0x18;
			g_Affichages[4] = 0x24;
			g_Affichages[3] = 0x48;
			g_Affichages[2] = 0x24;
			g_Affichages[1] = 0x18;
			g_Affichages[0] = 0x00;
		
			Scrutation(5000);
		
			Delai(5000);
		
			EteindreMatrice();
		}

/* -------------------------------- Fin de l'effet  Cur qui bat  -------------------------------- */



/* -------------------------------- Dbut du dessin d'une frimousse -------------------------------- */

		EteindreMatrice();



		/* Dessin d'une frimousse */

		g_Affichages[7] = 0x00;
		g_Affichages[6] = 0x20;
		g_Affichages[5] = 0x46;
		g_Affichages[4] = 0x50;
		g_Affichages[3] = 0x50;
		g_Affichages[2] = 0x46;
		g_Affichages[1] = 0x20;
		g_Affichages[0] = 0x00;
	
		Scrutation(100000);
	
		Delai(100000);

/* -------------------------------- Fin du dessin d'une frimousse -------------------------------- */



/* -------------------------------- Dbut du dessin d'une maison -------------------------------- */

		EteindreMatrice();



		/* Dessin d'une maison */

		g_Affichages[7] = 0x00;
		g_Affichages[6] = 0x10;
		g_Affichages[5] = 0xE8;
		g_Affichages[4] = 0x84;
		g_Affichages[3] = 0xC2;
		g_Affichages[2] = 0x84;
		g_Affichages[1] = 0xE8;
		g_Affichages[0] = 0x10;
	
		Scrutation(100000);
	
		Delai(100000);

/* -------------------------------- Fin du dessin d'une maison -------------------------------- */



/* -------------------------------- Dbut du dessin d'un sapin -------------------------------- */
	
		EteindreMatrice();



		/* Dessin d'un sapin */

		g_Affichages[7] = 0x00;
		g_Affichages[6] = 0x20;
		g_Affichages[5] = 0x34;
		g_Affichages[4] = 0x3E;
		g_Affichages[3] = 0xFF;
		g_Affichages[2] = 0x3E;
		g_Affichages[1] = 0x34;
		g_Affichages[0] = 0x20;
	
		Scrutation(100000);
	
		Delai(100000);
	
		EteindreMatrice();

/* -------------------------------- Fin du dessin d'un sapin -------------------------------- */



/* -------------------------------- Dbut de l'effet  Affichage d'un symbole  -------------------------------- */

		for(k = CARACTERE_ROTATION_0; k <= CARACTERE_ROTATION_270; k++)
		{
			for(p = CARACTERE_MIROIR_DESACTIVE; p < 2; p++)
			{
				AfficherCaractere(0, 0, k, p, 'F');
				Scrutation(50000);
				EteindreMatrice();
			}
		}

 		EteindreMatrice();

/* -------------------------------- Fin de l'effet  Affichage d'un symbole  -------------------------------- */



/* -------------------------------- Dbut de l'effet  Texte  -------------------------------- */

		for(k = 0; k < 3; k++)
		{
			EffetTexteDefilant(5000, 7, CARACTERE_ROTATION_0, CARACTERE_MIROIR_DESACTIVE, "BONJOUR !\0");
		}
		
		EteindreMatrice();

/* -------------------------------- Fin de l'effet  Texte  -------------------------------- */
	}
}



/* Fonction qui permet l'initialisation du microcontrleur STM32F100RB.

Paramtre d'entre :

Aucun.

Valeur de retour :

Aucune.

*/
void SystemInit(void)
{
	RCC->CR |= 0x01;
	while((RCC->CR & ~(1 << 1)) == 0x00);
	RCC->CR |= (1 << 16);
	while((RCC->CR & ~(1 << 17)) == 0x00);
	
	RCC->CFGR |= (4 << 18);
	RCC->CFGR |= (1 << 16);
	
	RCC->CFGR |= 0x02;
	
	RCC->CR |= (1 << 24);
	while((RCC->CR & ~(1 << 24)) == 0x00);
	RCC->CFGR |= 0x02;
}


